##parameters=
# $Id: create_level.py 2472 2007-10-29 10:09:33Z joachim $
"""
process the Application Form
return html renderer + psm
"""
request = context.REQUEST
import DateTime,logging
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
from Products.AdvancedQuery import Eq, Between, Le,In
try:
    aq_portal = context.portal_catalog.evalAdvancedQuery
except:
    aq_portal = context.portal_catalog_real.evalAdvancedQuery
aq_courses = context.courses_catalog.evalAdvancedQuery

current = DateTime.DateTime()
request = context.REQUEST
#session = request.SESSION
response = request.RESPONSE
redirect = response.redirect
logger = logging.getLogger('Skins.create_level')
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
member_id = str(member)
lt = context.portal_layouts
wt = context.waeup_tool
student = context.students_catalog(id=context.getStudentId())[0]
cert_id = student.course
current_level = student.level
current_session = student.session
in_progress =  request.get('in_progress','not started')
#level_created =  request.get('level_created','xxx')
create_level =  request.get('create_level',None)

##if context.hasObject(current_level) and create_level:
##    if getattr(context,current_level).objectIds():
##        logger.info('%s tried to add already existing level %s' % (student.id,current_level))
##    return
logger.info('%s started to create level %s' % (student.id,current_level))

##if in_progress in ('not started','started'):
##    session.set('in_progress','started')
##    view = context.in_progress_view(refresh=20,page='create_level?in_progress=started')
##    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
##    response.setHeader('Content-length','%d' % (len(view)))
##    response.setStatus('OK')
##    response.write(view)
##    response.write('')
##    if in_progress == 'started':
##        return

if context.hasObject(current_level):
    level = getattr(context,"%s" % current_level)
else:
    context.invokeFactory('StudentStudyLevel',"%s" % current_level)
    level = getattr(context,"%s" % current_level)
    context.portal_workflow.doActionFor(level,'open')
    #study_session = context.getSessionString()
    level.getContent().edit(mapping={'session': current_session})
    context.portal_workflow.doActionFor(level,'close_for_edit')
    #context.waeup_tool.doCommit()
level_id = level.getId()
student_id = context.getStudentId()
session_id = context.getLevelSession(level.getContent(),student_id,level_id)
results = []
records = []
if student.matric_no:
    results = context.results_import(matric_no = student.matric_no)
l = []
if student.session in ('6', '06') and results:
    carry_overs = results
    for co in carry_overs:
        course_id = co.CosCode
        if level.hasObject(course_id):    #already created
            continue
        carry_over = False
        query = Eq('code',co.CosCode)
        c_res = aq_courses(query)
        if not c_res:
            #logger.info('%s", course %s not found in courses_catalog' % (student.id,co.CosCode))
            continue
        course_cat_entry = c_res[0]
        passmark = getattr(course_cat_entry,'passmark',None)
        if not passmark:
            carry_over = co.GRADE in ('D','E','F')
        else:
            try:
                score = int(co.Score)
            except:
                # logger.info('%s, course %s has invalid score %s"' % (student.id,
                #                                                     course_id,
                #                                                     co.Score))
                continue
            if int(c_res[0].passmark) <= score:
                continue
            carry_over = True
        if not carry_over:
            continue
        if course_id in l:
            # don't add twice
            continue
        l += course_id,
        d = context.getCourseInfo(co.CosCode)
        d['course_id'] = course_id
        d['grade'] = co.GRADE
        d['carry_over'] = carry_over
        # course_id = level.invokeFactory('StudentCourseResult',"%s_co" % course_id)
        # course_result = getattr(level,course_id)
        # context.portal_workflow.doActionFor(course_result,'open')
        # course_result.getContent().edit(mapping=d)
        # context.waeup_tool.doCommit()
        d['code'] = course_id
        d['student_id'] = student_id
        d['level_id'] = level_id
        d['session_id'] = session_id
        records.append(d)

#level['create_course_results'](cert_id,current_level)
res = context.portal_catalog(portal_type="Certificate", id = cert_id)
if res:
    cert = res[0]
    path = cert.getPath()
    query = Eq("path","%s/%s" % (path,current_level)) &\
            Eq('portal_type','CertificateCourse')
    courses = aq_portal(query)
    for c in courses:
        course_id = "%s" % c.getId
        if course_id in l:
            # don't add twice
            continue
        l += course_id,
        d = context.getCourseInfo(c.getId)
        # course_id = level.invokeFactory('StudentCourseResult',c.getId)
        # course_result = getattr(level,course_id)
        # context.portal_workflow.doActionFor(course_result,'open')
        # d['core_or_elective'] = True
        # course_result.getContent().edit(mapping=d)
        # context.waeup_tool.doCommit()
        d['carry_over'] = False
        d['core_or_elective'] = getattr(c.getObject().getContent(),'core_or_elective')
        d['course_id'] = course_id
        d['student_id'] = student_id = context.getStudentId()
        d['level_id'] = level_id
        d['session_id'] = session_id
        #context.course_results.addRecord(**d)
        records.append(d)
if records:
    context.course_results.addMultipleRecords(records)
logger.info('%s finished to create level %s' % (student.id,current_level))

#if current_session == '05':
#    next_session = '06'
#    next_level = "%s" % (int(current_level) + 100)
#    study_course = getattr(student,'study_course')
#    context.portal_workflow.doActionFor(study_course,'open')
#    study_course_doc = study_course.getContent()
#    study_course_doc.edit(mapping= {'current_level': next_level,
#                                    'current_session': next_session,})
#    context.portal_workflow.doActionFor(study_course,'close_for_edit')

return response.redirect("%s/%s" % (context.absolute_url(),current_level))
